/******************************************************************************/
/* Files da includere                                                         */
/******************************************************************************/

#include <xc.h>             /* XC8 General Include File */
#include <stdint.h>         
#include <stdbool.h>        

#include "header.h"

/******************************************************************************/
/* Funzioni                                                                   */
/******************************************************************************/

//Inizializza il PIC
void InitApp(void)
{
    //Attivo il PLL
    OSCTUNEbits.PLLEN = 1;
    __delay_ms(10);

    //Configuro le porte D come uscite
    TRISD=0;
    PORTD=0;

    //Pin TX e RX del modulo UART
    TRISC6=0;
    TRISC7=1;

    
    
    //Configurazione modulo UART
    //Trasmissione asincrona a 8bit, alta velocit e generatore del baud-rate a 8bit
    //Invio e ricezione dati non invertita e idle state ad alto livello
    TXSTA1=0b00100100;
    RCSTA1=0b10010000;
    BAUDCON1=0;
    SPBRG1=155;         //Baud=19200 (Fout=Fosc/(16*(SPBRG1+1))
    
    
 
/*
    //Inizializzazione I2C
    SSP1STAT=0b10000000;
    SSP1CON1=0b00101000;
    SSP1CON2=0;
    SSP1ADD=119;    //100KHz

 */

    

     
}


//Dato in ingresso una stringa, invia un carattere per volta alla seriale.
void stampaTesto(char *t)
{
    while (*t)
    {
        while(!TX1IF);
        TXREG1=*t;
        t++;
    }
}

//Converto e invio della temperatura letta
void stampaTemp(unsigned char t1, unsigned char t2)
{
    unsigned char s_temp[5];
    s_temp[0]=(t1/10)+48;       //Ottengo la cifra delle decine
    s_temp[1]=(t1%10)+48;       //Ottengo la cifra delle unit
    s_temp[2]=44;               //Corrisponde alla virgola
    
    t2=t2>>4;                   //Shifto di 4 posizioni il dato dei decimali
    t2*=10;                     //Moltiplico per dieci per non dover usare i decimali
    t2=t2>>4;                   //E divido per 16 (i decimali della temp sono espressi in 16simi di grado)
    s_temp[3]=t2+48;            //Sommo 48 che corrisponde allo zero in ascii


    s_temp[4]=0;                //Carattere di terminazione
    //Invio la tempertura letta
    stampaTesto("Temperatura misurata: ");
    stampaTesto(s_temp);
    stampaTesto("\n");
}
//Funzione delay per ritardi pi lunghi
void delay_ms(int ms)
{
    int i;
    for (i=0;i<ms;i++) __delay_ms(1);
}